*****************************************************************************
* Modulname:	SOKOBAN
* Modultype:	Library main routines
* Dest.Comp.:	HP38G
* Language:	System RPL
* Author:	Detlef Mueller, Bellerbek 33, 22559 Hamburg, Germany
* Interface:	SOBA
* Description:
* To do:	- Speed up GROB+#
*
* Copyright :
*	(c) 1991-98 by Detlef Mueller. ALL rights reserved.
*
* $Id: SOBA.S 1.5.1.9 1998/11/17 20:27:22 Detlef Rel $
*
* $Log: SOBA.S $
* Revision 1.5.1.9  1998/11/17 20:27:22  Detlef
* Added [*] keyhandler -- pops up a choosebox, providing "level jumps"
* to 1,10,20,40. Note that 1 fill save the game, effectively doing an
* reset.
*
* Revision 1.5.1.8  1998/11/16 03:43:56  Detlef
* Added GARBAGE at the beginning of Play, should avoid nasty collections
* while in key repeats. Set to 50 levels, defined FOURTY, repl. 72/76 by
* entry versions, beatyfied note and added some inline doc.
*
* Revision 1.5.1.7  1998/11/15 15:29:41  Detlef
* Instead of TURNMENUOFF the menu is fade out now, disabled VIEWS w/in
* the game, added DoBadKey if trying to move where you can't move, removed
* usage of #1+DUP and enabled sound in Fine whether sound is on or not.
*
* Revision 1.5.1.6  1998/11/14 19:06:06  Detlef
* Changed the whole game to become an Aplet. The Aplet bases on
* Jean-Yves Avenard's "Empty Aplet" and TrigExampel frames. Done
* various other changes as well -- see SOKOBAN.DOC
*
* Revision 1.5.1.5  1998/10/27 18:59:53  Detlef
* Brought to v2.0 ('48 v1.9).
*
* Revision 1.5.1.4  1996/11/01 22:59:49  Detlef
* Moved level data to the end, added defines for level inclusion.
*
* Revision 1.5.1.3  1996/11/01 22:42:01  Detlef
* Changed to new build-sheme.
*
* Revision 1.5.1.2  1996/11/01 22:38:51  Detlef
* Changed PGSB to x..., removed SetLvl, minor packs.
*
* Revision 1.5.1.1  1996/11/01 22:34:27  Detlef
* SokoBan for the HP38G !
*
*****************************************************************************

    TITLE	SOKOBAN Aplet

*****************************************************************************
*		INCLUDE FILES
*****************************************************************************

    INCLUDE	soba.h


    INCLUDE	common38.h

*****************************************************************************
*		APLET LAYOUT
*****************************************************************************

ASSEMBLE
	Dir_Head 7,SokoBan,601
RPL

	StndtType

    INCLUDE	share38.h

ASSEMBLE
	Vfield  L34,IntTable
	CON(5)	=DOHSTR
	REL(5)  endLink

	Link	_SOBA
	Link	_Play
	Link	_Repeater
	Link	_Up
	Link	_Left
	Link	_Down
	Link	_Right
	Link	_MovRem
	Link	_Level!
	Link	_Level@
	Link	_ShowLvl
	Link	_RstLvl
	Link	_XorAct
	Link	_Logo
	Link	_Fine
	Link	_#=PosArry
	Link	_Hxs>#
	Link	_LvlData
	Link	_LvlPic
	Link	_FadeMenuOff
endLink
RPL

DEFINE	SOBA		INT_00
DEFINE	Play		INT_01
DEFINE	Repeater	INT_02
DEFINE	Up		INT_03
DEFINE	Left		INT_04
DEFINE	Down		INT_05
DEFINE	Right		INT_06
DEFINE	MovRem		INT_07
DEFINE	Level!		INT_08
DEFINE	Level@		INT_09
DEFINE	ShowLvl		INT_0A
DEFINE	RstLvl		INT_0B
DEFINE	XorAct		INT_0C
DEFINE	Logo		INT_0D
DEFINE	Fine		INT_0E
DEFINE	#=PosArry	INT_0F
DEFINE	Hxs>#		INT_10
DEFINE	LvlData		INT_11
DEFINE	LvlPic		INT_12
DEFINE	FadeMenuOff	INT_13

ASSEMBLE
	Vfield  IntTable,DirVar
RPL
ASSEMBLE
	CON(5)	=DOHSTR
	REL(5)  endCode
RPL

*****************************************************************************
*		DEFINES
*****************************************************************************

DEFINE	Version$	"V2.0(c)DM98"
DEFINE	Title$		"SOKOBAN"

DEFINE	MAXLEVEL	FIFTY

ASSEMBLE

L01-10		EQU	1
L11-20		EQU	1
L21-30		EQU	1
L31-40		EQU	1
L41-50		EQU	1

=#4-		EQU	#DF143

=INT_10 	EQU	#7D7ED
=INT_11 	EQU	#7D7FA
=INT_12 	EQU	#7D807
=INT_13		EQU	#7D814
=INT_14		EQU	#7D821
=INT_15		EQU	#7D82E
=INT_16		EQU	#7D83B
=INT_17		EQU	#7D848
=INT_18		EQU	#7D855
=INT_19		EQU	#7D862
=INT_1A		EQU	#7D86F
=INT_1B		EQU	#7D87C
=INT_1C		EQU	#7D889
=INT_1D		EQU	#7D896
=INT_1E		EQU	#7D8A3
=INT_1F		EQU	#7D8B0

RPL

DEFINE	FOURTY		FORTY

DEFINE	@x		TopicVar1@	( *Actor x* )
DEFINE	!x		TopicVar1!
DEFINE	@y		TopicVar2@	( *Actor y* )
DEFINE	!y		TopicVar2!
DEFINE	@n		TopicVar3@	( *Locations to fill* )
DEFINE	!n		TopicVar3!
DEFINE	@lvl		TopicVar4@	( *Level* )
DEFINE	!lvl		TopicVar4!
DEFINE	@ug		TopicVar5@	( *Undo grob* )
DEFINE	!ug		TopicVar5!
DEFINE	@un		TopicVar6@	( *Undo n* )
DEFINE	!un		TopicVar6!
DEFINE	@ud		TopicVar7@	( *Undo direction* )
DEFINE	!ud		TopicVar7!

DEFINE	@Store		LastBut3
DEFINE	!Store		LastBut3 REPLACE DROP

DEFINE	SF_Sound	FIFTYSIX

DEFINE	TICK		TWO 400 setbeep

*****************************************************************************
*		OBJECTS
*****************************************************************************

*** xSOBA *******************************************************************
* Interface :	( --> )
* Description :	Main program SOKOBAN
*****************************************************************************

NAMELESS	_SOBA
::
    StndCheck

    ' 					( *View entry* )
    ::	RECLAIMDISP

	HARDBUFF
	HARDHEIGHT CHECKHEIGHT		( *Enshure hardbuff is 131 * 64* )

	NAMELESS	_FadeMenuOff
	::
	    SIXTYFOUR FIFTYSIX
	    DO
		INDEX@ LINECHANGE SLOW SLOW
	    LOOP
	;

	Logo Level@
    ;
    '					( *View exit* )
    ::	TURNMENUON
	%0AllTopicVs
	RECLAIMDISP
	SetDAsBad
    ;

    ' DropJunk				( *View display* )

    ' Play    				( *View hard key handlers* )

    TRUE				( *Allow normal keys* )
    NULL{}				( *No menu* )
    ONE 				( *Initial menu page* )

    ' ERRJMP				( *Error object* )
;

*** Play ********************************************************************
* Interface :	( --> )
* Description :	SokoBan' keyhandler, actually plays the game...
* Calls :	Up Left Down Right Level! RstLvl Fine
* Modifies :	n lvl
*****************************************************************************

NAMELESS	_Play
::
    GARBAGE

    kpNoShift #=casedrop		( *Unshifted key* )
    ::
	kcUpArrow ?CaseKeyDef		( *Up* )
	::  TakeOver
	    Repeater kcUpArrow Up
	;
	kcLeftArrow ?CaseKeyDef		( *Left* )
	::  TakeOver
	    Repeater kcLeftArrow Left
	;
	kcDownArrow ?CaseKeyDef		( *Down* )
	::  TakeOver
	    Repeater kcDownArrow Down
	;
	kcRightArrow ?CaseKeyDef	( *Right* )
	::  TakeOver
	    Repeater kcRightArrow Right
	;

	kcEnter ?CaseKeyDef		( *Store game* )
	::  TakeOver
	    Level!
	;

	kcDel ?CaseKeyDef		( *Recall stored game* )
	::  TakeOver
	    Level@
	;

	kcPlus ?CaseKeyDef		( *Inc. level* )
	::  TakeOver
	    @lvl #1+
	    MAXLEVEL #=casedrop DoBadKey
	    !lvl RstLvl
	;
	kcMinus ?CaseKeyDef		( *Dec. level* )
	::  TakeOver
	    @lvl ZERO #=casedrop DoBadKey
	    #1- !lvl RstLvl
	;

	kcNegate ?CaseKeyDef		( *Toggle sound on/off* )
	::  TakeOver
	    SF_Sound DUP SysITE ClrSysFlag SetSysFlag
	;

	kcTimes ?CaseKeyDef		( *Level select* )
	::  TakeOver

	    'DROPFALSE
	    "Goto level\1F"
	    SEVENTEEN

	    {
		{   "10" NINE }
		{   "20" NINETEEN }
		{   "30" TWENTYNINE }
		{   "40" THIRTYNINE }
		{   "1/Reset" ZERO }
	    }

	    ONE Choose

	    FadeMenuOff

	    NOT?SEMI

	    GetPart2 DUP !lvl RstLvl

	    #0=case Level!
	;

	kcLeftShift #=casedrpfls	( *Allow shift* )

	kcPlotView ?CaseKeyDef DoBadKey	( *Disallow Plot/Symb/Num views* )
	kcSymbView ?CaseKeyDef DoBadKey
	kcNumView  ?CaseKeyDef DoBadKey
	kcVarsMenu ?CaseKeyDef DoBadKey	( *Disallow Vars/Math menus* )
	kcMathMenu ?CaseKeyDef DoBadKey

	DUP kpNoShift IsTaskSwKey? casedrpfls

	DROP 'DoBadKeyT
    ;

    kpLeftShift #=casedrop		( *Shifted key* )
    ::
	kcLeftShift #=casedrpfls	( *Allow shift* )

	kcOn #=casedrpfls		( *On ON turn off :*)

	kcEnter ?CaseKeyDef		( *Undo last step* )
	::  TakeOver
	    @ud
	    ZERO #=casedrop DoBadKey	( *Undo data not valid* )

	    ZERO !ud			( *Mark undo data as invalid* )
	    @n @un #- !n		( *Correct n* )
	    @ug HARDBUFF @x @y 5ROLL	( --> grob hb x y # )
	    ::				( *Undo ...* )
		ONE #=casedrop		( *right* )
		::  OVER #4- !x
		;
		TWO #=casedrop		( *left* )
		::  OVER #4+ !x
		    SWAP #4- SWAP
		;
		THREE #=casedrop	( *up* )
		::  DUP #4+ !y
		    #4-
		;
		DROP DUP #4- !y		( *down* )
	    ;
	    GROB! XorAct

	    @n #0=case Fine		( *Finish level -> yup, fine ..* )
	;

	kcDel ?CaseKeyDef		( *Reset level* )
	::  TakeOver
	    RstLvl
	;

	kcPlotView ?CaseKeyDef DoBadKey	( *Disallow Plot/Symb/Num views* )
	kcSymbView ?CaseKeyDef DoBadKey
	kcNumView  ?CaseKeyDef DoBadKey
	kcMathMenu ?CaseKeyDef DoBadKey	( *Disallow Sketch view* )
	kcLibrary  ?CaseKeyDef DoBadKey	( *Disallow Views* )

	DUP kpLeftShift IsTaskSwKey? casedrpfls

	DROP 'DoBadKeyT
    ;

    2DUP IsTaskSwKey? case2drpfls	( *Task-switch key ?* )

    2DROP 'DoBadKeyT		( *Illegal keyplane, do nothing* )
;

*** Repeater ****************************************************************
* Interface :	( #kc --> )
* Description :	SOBA's own repeater
* Calls :	Fine
*****************************************************************************

NAMELESS	_Repeater		( kc ob --> )
::
    'R'R RDROP DUP EVAL
    [BEGIN]				( *While key down ..* )
	2DUP SWAP REPKEY?
    [WHILE]
	EVAL				( *Execute ob* )
    [REPEAT]
    3DROP

    @n #0=case Fine			( *If finished level, fine...* )
;

*** Up **********************************************************************
* Interface :	( --> )
* Description :	Move actor up one step
* Uses :	x
* Modify :	y n screen
*****************************************************************************

NAMELESS	_Up
::
    ARRY
    [	#5AC2 #7CDB #6D79 #2ABE #1D05 #EF7A #C963
	#D8C1 #9F06 #A8BD #7956 #FB55 #4EED #CCEE
    ]
    HARDBUFF
    @x @y EIGHT #- @x #4+ @y		( --> [] hb #x #y-8 #x+4 #y )
    SUBGROB DUP				( --> [] grob grob )
    OCRC SWAPDROP Hxs>#			( --> [] grob #crc )
    ROTSWAP				( --> grob [] #crc )
    #=PosArry DUP#0= case2drop DoBadKey

    SWAP !ug ZERO !un THREE !ud
    @y #4- !y

    FALSE HARDBUFF			( --> #pos flg grob )
    3PICK ELEVEN #< case
    ::	ASSEMBLE
	MKSGROB 4,8,2070200020702000
	RPL
	@x @y GROB+# 2DROP TICK
    ;
    ASSEMBLE
	MKSGROB 4,12,705070005020500020702000
    RPL
    @x @y #4- MovRem
;

*** Left ********************************************************************
* Interface :	( --> )
* Description :	Move actor left one step
* Uses :	y
* Modify :	x n screen
*****************************************************************************

NAMELESS	_Left
::
    ARRY
    [	#2487 #E848 #913F #0713 #B2AB #27BC #EB73
	#9204 #0428 #B190 #0DE5 #BB66 #B85D #0EDE
    ]
    HARDBUFF
    @x EIGHT #- @y @x @y #4+		( --> hb #x-8 #y #x #y+4 )
    SUBGROB DUP
    OCRC SWAPDROP Hxs>#
    ROTSWAP
    #=PosArry DUP#0= case2drop DoBadKey

    SWAP !ug ZERO !un TWO !ud
    @x #4- !x

    FALSE HARDBUFF			( --> #pos flg grob )
    3PICK ELEVEN #< case
    ::	ASSEMBLE
	MKSGROB 8,4,22772200
	RPL
	@x @y GROB+# 2DROP TICK
    ;
    ASSEMBLE
	MKSGROB 12,4,7520527075200000
    RPL
    @x #4- @y MovRem
;

*** Down ********************************************************************
* Interface :	( --> )
* Description :	Move actor down one step
* Uses :	x
* Modify :	y n screen
*****************************************************************************

NAMELESS	_Down
::
    ARRY
    [	#5AC2 #960D #EF7A #7956 #CCEE #6D79 #A1B6
	#D8C1 #4EED #FB55 #2ABE #A8BD #9F06 #1D05
    ]
    HARDBUFF
    @x @y #4+ @x #4+ @y TWELVE #+ 	( --> hb #x #y+4 #x+4 #y+12 )
    SUBGROB DUP
    OCRC SWAPDROP Hxs>#
    ROTSWAP
    #=PosArry DUP#0= case2drop DoBadKey

    SWAP !ug ZERO !un FOUR !ud
    @y #4+ !y

    FALSE HARDBUFF			( --> #pos flg grob )
    3PICK ELEVEN #< case
    ::	ASSEMBLE
	MKSGROB 4,8,2070200020702000
	RPL
	@x @y #4- GROB+# 2DROP TICK
    ;
    ASSEMBLE
	MKSGROB 4,12,207020005020500070507000
    RPL
    @x @y #4- MovRem
;

*** Right *******************************************************************
* Interface :	( --> )
* Description :	Move actor right one step
* Uses :	y
* Modify :	x n screen
*****************************************************************************

NAMELESS	_Right
::
    ARRY
    [	#2487 #88BB #27BC #0DE5 #0EDE #913F #3D03
	#9204 #B85D #BB66 #0713 #B190 #0428 #B2AB
    ]
    HARDBUFF
    @x #4+ @y @x TWELVE #+ @y #4+	 ( --> hb #x+4 #y #x+12 #y+4 )
    SUBGROB DUP
    OCRC SWAPDROP Hxs>#
    ROTSWAP
    #=PosArry DUP#0= case2drop DoBadKey

    SWAP !ug ZERO !un ONE !ud
    @x #4+ !x

    FALSE HARDBUFF			( --> #pos flg grob )
    3PICK ELEVEN #< case
    ::	ASSEMBLE
	MKSGROB 8,4,22772200
	RPL
	@x #4- @y GROB+# 2DROP TICK
    ;
    ASSEMBLE
	MKSGROB 12,4,2570725025700000
    RPL
    @x #4- @y MovRem
;

*** MovRem ******************************************************************
* Interface :	( #pos gr hb x y --> )
* Description :	Remainder of Up, Left, Down, Right
* Uses :	lvl x y n screen
* Modifies :	n un screen
*****************************************************************************

NAMELESS	_MovRem
::
    RDROP
    GROB+# DROP				( --> #pos )
    TICK

    THIRTEEN #=casedrop
    ::	@n #1- !n
	MINUSONE !un
    ;

    FOURTEEN #<> ?SEMI
    @n #1+ !n
    ONE !un
;

*** Level! ******************************************************************
* Interface :	( --> )
* Description :	Store a snapshot from the game into our store
* Uses :	lvl x y n screen
* Modifies :	Store
*****************************************************************************

NAMELESS	_Level!
::
    SF_Sound SysITE TRUE FALSE
    @x @y @n @lvl
    HARDBUFF ZEROZERO SEVENTYSIX SIXTYFOUR SUBGROB
    SIX {}N 				( sf #x #y #n #lvl grob --> {} )

    !Store
;

*** Level@ ******************************************************************
* Interface :	( --> )
* Description :	Setup the game environment with the data of the store.
* Uses :	Store
* Modifies :	lvl x y n screen
*****************************************************************************

NAMELESS	_Level@
::
    @Store

    INCOMPDROP				( {} --> sf #x #y #n #lvl grob )
    ZEROZERO ROT XYGROBDISP
    !lvl !n !y !x
    ZERO !ud				( *Undo data not valid* )
    SF_Sound SWAP ITE SetSysFlag ClrSysFlag
    ShowLvl				( *Display level no.* )
;

*** ShowLvl *****************************************************************
* Interface :	( --> )
* Description :	Draw level no. into the logo
* Uses :	lvl
* Modifies :	screen
*****************************************************************************

NAMELESS	_ShowLvl
::
    @lvl #1+ #>$
    DUPLEN$ #1= IT
    ::	CHR_Space >H$
    ;
    $>grob HARDBUFF
    103 THIRTYSIX GROB!
;

*** RstLvl ******************************************************************
* Interface :	( --> )
* Description :	Prepare screen and tmp.vars for level n
* Uses :	lvl
* Modifies :	x y n screen
* Calls :	ShowLvl LvlPic LvlData
*****************************************************************************

NAMELESS	_RstLvl
::
    ShowLvl
    LvlPic				( --> $ )
    @lvl SEVENTYSIX #* #1+
    DUP SEVENTYFIVE #+			( $ --> $ #lvl*76+1 #lvl*76+76 )
    SUB$				( *Get compressed level image* )

    ZEROZERO !x !y			( x = y = 0, --> $ )

    HARDBUFF ZEROZERO SEVENTYSIX SIXTYFOUR
    GROB!ZERODRP			( *Clear game area* )

    GARBAGE				( *Force garbage collection* )

    BEGIN
	DUP @y NINETEEN #* @x #+

    CODE				( #16/ )
*				A
	GOSBVL	=$jPOP#		#
	GOSBVL	=$jSAVPTR
	ASR	A		#/16
	GOVLNG	=$jPUSH#ALOOP
    ENDCODE

	#1+ SUB$1#			( ... --> $ #[y*19+x]/16+1 )

	FOUR ZERO
	DO
	    DUP THREE #AND		( $ # --> $ # #' *Get lower two bits* )
	    DUP#0= ITE_DROP
	    ::  {   GROB 12 400004000050A050A0	( Border )
		    GROB 12 400004000070507000	( Box )
		    GROB 12 400004000000200000	( Dot )
		}
		SWAP NTHCOMPDROP	( $ # #' {} --> $ # grob )
		HARDBUFF @x @y GROB!
	    ;

	    #2/ #2/			( $ # --> $ #' *Shift out lower 2 bits* )
	    @x #4+			( $ # --> $ # # )
	    SEVENTYTWO OVER#< IT
	    ::	DROPZERO
		@y #4+ !y
	    ;

	    !x
	LOOP
	DROP
	@y SIXTY #>
    UNTIL
    DROP

    LvlData

    @lvl FOUR #* #1+ DUP #3+		( --> {} #lvl*4+1 #lvl*4+4 )
    SUBCOMP INCOMPDROP			( ... --> #tofill #x #y {} )
    DUPNULL{}?
    ITE_DROP
    ::	INNERCOMP #2/
	ZERO_DO (DO)
	    GROB 12 400004000070707000	( *Filled box* )
	    HARDBUFF 2SWAP		( --> ... hb grob #x #y )
	    GROB!
	LOOP
    ;

    !y !x !n
    ZERO !ud				( *Undo data not valid* )
    XorAct				( *XOR actor at x, y* )
;

*** XorAct ******************************************************************
* Interface :	( --> )
* Description :	XOR the actor at pos x,y into the game area
* Uses :	x y
* Modifies :	screen
*****************************************************************************

NAMELESS	_XorAct
::
    FALSE HARDBUFF
    GROB 12 400004000020702000
    @x @y GROB+# DROP
;

*** Logo ********************************************************************
* Interface :	( --> )
* Description :	Draw the SOKOBAN logo
* Uses :	Version$ Title$
* Modifies :	screen
*****************************************************************************

NAMELESS	_Logo
::
    HARDBUFF 83 ONE BINT_128d TWENTY
    GROB!ZERODRP
    86 FIFTYSIX BINT_128d OVER
    LINEOFF

    86 FIFTYSEVEN Version$ $>grob
    83 TWENTY
    ASSEMBLE
	MKGROB 47,36
	NIBHEX	FFFFFFFFFFF7555555555555BAAAAAAAAAA655FFFFFF7555BA100000EAA655
	NIBHEX	100000A555BA1000002BA6551000002655BA1EFFF12CA6551600A12455BA1A
	NIBHEX	00512CA6551218A12455BA1220512CA65512CFF12455BA1240012CA6551240
	NIBHEX	012455BA1240012CA6551240012455BA1240012CA6551240012455BA124001
	NIBHEX	2CA6551240012455BA1240012CA65512CFF12455BA1245122CA65512CA0424
	NIBHEX	55BA1245082CA65512C0003455BA12CFFF3CA6553200000455BA6200000CA6
	NIBHEX	55D200000455BAA300000CA6555FFFFFF755BAAAAAAAAAA6FFFFFFFFFFF7
    RPL
    85 SIX Title$ $>GROB

    XYGROBDISP XYGROBDISP XYGROBDISP

    83 ONE BINT_128d OVER
    OVER TWO OVER SEVENTEEN
    83 OVER 127 OVER
    83 TWO 83 SIXTEEN
    84 EIGHTEEN 129 EIGHTEEN
    OVER TWO OVER SEVENTEEN

    SIX ZERO
    DO
	LINEON
    LOOP
;

*** Fine ********************************************************************
* Interface :	( --> )
* Description :	Draw the fine logo et c.
* Modifies :	lvl n screen
* Calls :	Logo RstLvl Level!
*****************************************************************************

NAMELESS	_Fine
::
    SF_Sound DUP SysITE TRUE FALSE	( *Get Soundflag* )
    SF_Sound ClrSysFlag			( *Enable sound* )

    ASSEMBLE
	MKGROB 38,55
	NIBHEX	00F10000000802000000040200000004040000003604EC3E404504154150C7
	NIBHEX	041541D02C061D3F5128C91EF15218080103501010901E5010186800302817
	NIBHEX	4880402820484080244048508070C1E0708270AF7BF043801BA60FF0F1050C
	NIBHEX	66015301080102A28088A00257408EF102A9308702815150C30041A1B0A300
	NIBHEX	A2515E520061A1100600E25110080051A1210000D25120000841A1210008C2
	NIBHEX	5140000441A1600002C251A0008341A12100F2C251270C3241A1220022C251
	NIBHEX	24002241A1240832C25124082241A1240022C25124002241A1240022C25124
	NIBHEX	004241A12800C2C2512C004341A12C00C3C25328004041A6280040C25D2800
	NIBHEX	4041AA380080C255FF008F71AAAA100BA2FFFF108FF30000FF7000
    RPL
    HARDBUFF 87 TWO GROB!

    300 554 OVER 659 SEVENTYFIVE 740 150 6PICK 4PICK 6PICK 4PICK OVER
    SIX ZERO
    DO
	setbeep
    LOOP

    VERYVERYSLOW

    @lvl #1+
    MAXLEVEL OVER#= IT
    ::	HARDBUFF ZEROZERO SEVENTYSIX SIXTYFOUR GROB!ZERODRP
	ONE TWENTYTHREE "You did it !" $>GROB XYGROBDISP
	ONE THIRTYONE "Bye, bye \1F" $>GROB XYGROBDISP
	ZERO
	BEGIN
	    #1+
	    {   ASSEMBLE
		MKSGROB 6,10,00C3C18381818181C181
		MKSGROB 7,10,82C1C18381C1C585C2C0
		MKSGROB 7,10,0041C18183C1C1E3C366
		MKSGROB 6,10,0081C3C38181C181E323
		MKSGROB 6,10,00C3C1C381818181C181
		MKSGROB 7,10,82C1C18381818585C2C0
		MKSGROB 7,10,0041C18183818183C366
		MKSGROB 6,10,0081C3C381818181E323
		RPL
	    }
	    OVER SEVEN #AND #1+ NTHCOMPDROP
	    HARDBUFF 3PICK FIFTYFOUR
	    GROB!
	    DUP THREE #AND #2= IT
	    ::  THREE 400 setbeep
	    ;
	    % 0.1 dowait
	    ATTN? IT
	    ::  DROP SEVENTYFOUR
		ATTNFLGCLR
	    ;
	    SEVENTYFOUR OVER#=
	UNTIL
	DROP FLUSHKEYS

	DROPZERO			( *Reset to level 1...* )
    ;

    !lvl

    ITE SetSysFlag ClrSysFlag		( *Restore soundflag* )

    Logo RstLvl
    Level!
;

** #=PosArry ****************************************************************
* Interface :	( arry # --> #pos/#0 )
* Description :	Search in <arry> of BINT's for <#>.
* Defines :	Psh#ALp
*****************************************************************************

NAMELESS	_#=PosArry
CODE
* CPU			A	B	C	D0	D1
	GOSBVL	=$jPOP#	n
	D1=D1+  5		update D
	D=D+1   A		update M
	GOSBVL	=$jSAVPTR
	D1=D1-	5					&&arry
	C=DAT1	A			&arry
	D0=C					&arry
	D1=C						&arry
	D0=D0+	5				&len
	C=DAT0	A			len
	B=C	A		len
	CD1EX				&arry
	C=C+B	A			&lastelem
	D1=C						&lastelem
	D0=D0+	15				&dim1len
	C=DAT0	A			dim1len
	B=A	A		n
	A=C	A	pos
	GOTO	PAEntry

PALoop	C=DAT1	A			x
	?C=B	A
	GOYES	PAFound
	D1=D1-	5					&prev.elem
PAEntry	A=A-1	A	--pos
	GONC	PALoop

PAFound	A=A+1	A	++pos
Psh#ALp	GOVLNG	=$jPUSH#ALOOP
ENDCODE

** Hxs># ********************************************************************
* Interface :	( hxs --> # )
* Description :	Convert HXS string to bint
*****************************************************************************

NAMELESS	_Hxs>#
CODE
	A=DAT1  A       get hxs ptr
	D1=D1+  5
	D=D+1   A       update M
	GOSBVL  =$jSAVPTR
	D1=A
	D1=D1+  5       point to length field
	A=DAT1  A       get length of hxs
	D1=D1+  5       point to data
	LC(5)   5       disregard length field itself
	A=A-C   A       get # of nibbles
	P=      4
	?A>=C   A       at least 5 nibbles?
	GOYES   has5
	A=A-1   A
	GOC     zero    null hxs
	ACEX    B        get length in C
	CPEX    0       length in P
	A=0     A
has5    A=DAT1  WP      get all the nibbles, up to 5
pbin    P=      0
	GOVLNG  =$jPUSH#ALOOP

zero    A=0     A       return zero for null hxs
	GOC    pbin     (B.E.T.)
ENDCODE

*****************************************************************************
*		LEVEL DATA
*****************************************************************************

    INCLUDE	sobalvl.inc

ASSEMBLE
endCode
RPL

*****************************************************************************
*		LEVEL STORE
*****************************************************************************

ASSEMBLE
	Vfield DirVar,DirCode
RPL
  {
	FALSE		( *Sound flag {ON}* )
	FORTYFOUR	( *Actor pos x* )
	FORTYFOUR	( *Actor pos y* )
	SIX		( *No. of free storage pos n*)
	ZERO		( *Level no. {1}* )
			( *Current picture* )
    ASSEMBLE
	MKGROB 76,64

	NIBHEX	00000000000000000000000000000000000000000000000000000000000000
	NIBHEX	00000000000000000000000000000000000000000000000000000000000000
	NIBHEX	00000000000000000000000000000000000000000000000000000000000000
	NIBHEX	00000000000000000000000000000000000000000000000000000000005555
	NIBHEX	5000000000000000AAAAA00000000000000055555000000000000000AAAAA0
	NIBHEX	0000000000000050005000000000000000A000A00000000000000050005000
	NIBHEX	000000000000A000A00000000000000057005000000000000000A500A00000
	NIBHEX	000000000057005000000000000000A000A000000000000055500755000000
	NIBHEX	000000AAA005AA00000000000055500755000000000000AAA000AA00000000
	NIBHEX	000050070705000000000000A005050A000000000000500707050000000000
	NIBHEX	00A000000A000000000055505055050005555550AAA0A0AA0A000AAAAAA055
	NIBHEX	505055050005555550AAA0A0AA0A000AAAAAA050005055055555000050A000
	NIBHEX	A0AA0AAAAA0022A050005055055555000050A000A0AA0AAAAA0000A0507007
	NIBHEX	00000000000050A05005000000000022A050700700000000000050A0000000
	NIBHEX	0000000000A055555055505255000050AAAAA0AAA0A7AA0022A05555505550
	NIBHEX	5255000050AAAAA0AAA0A0AA0000A0000050000055555555500000A00000AA
	NIBHEX	AAAAAAA0000050000055555555500000A00000AAAAAAAAA000005555555000
	NIBHEX	0000000000AAAAAAA000000000000055555550000000000000AAAAAAA00000
	NIBHEX	00000000000000000000000000000000000000000000000000000000000000
	NIBHEX	00000000000000000000000000000000000000000000000000000000000000
	NIBHEX	0000000000000000000000000000000000000000
    RPL
  }

ASSEMBLE
	Vfield DirCode,DirAlt
RPL
  { }

*****************************************************************************
*		Aplet note -- here (c) & quick reference
*****************************************************************************

ASSEMBLE
	Vfield DirAlt,DirNot
RPL
  " SokoBan for the '38G\n $Revision: 1.5.1.9 $\n\n  '98 Detlef Mller\n   <detlef@provi.de>\n\n    SokoBan' ApKeys\n    Direct actor\n^ENTER  Undo last step\nENTER   Snapshot game\nDEL     Restore game\n^DEL    Reset level\n+       Next level\n-       Prev. level\n-X      Toggle sound\n*       Select level\n\n\n"
*234567890123456789012


ASSEMBLE
	Vfield DirNot,DirEnd
RPL
  { }

******************************************************************************
*			End of SOBA.S
******************************************************************************
