*****************************************************************************
* Modulname:	Sokoban
* Modultype:	Data section of SOKOBAN
* Dest.Comp.:	HP48/HP38G
* Language:	System RPL
* Author:	Detlef Mueller, Bellerbek 33, 22559 Hamburg, Germany
* Description:	SOKOBAN database
* To do:
* Edition History :
*	0.000	16.09.1991	DM	Alpha version
*
* $Id: SOBALVL.INC 1.3 1996/11/01 23:00:52 Detlef Rel $
*
* $Log: SOBALVL.INC $
* Revision 1.3  1996/11/01 23:00:52  Detlef
* Added conditional inclusion of levels.
*
* Revision 1.2  1996/11/01 22:27:28  Detlef
* Will now be included by SOBA.S
*
* Revision 1.1  1996/08/18 23:54:10  Detlef
* Initial revision
*
*****************************************************************************

     STITLE	Sokoban level data

*****************************************************************************
*		INCLUDE FILES
*****************************************************************************


*    INCLUDE	sokoban.h


*** LvlData *****************************************************************
* Interface :	( --> {} )
* Description : nrtofill actx acty
* Ed. History :
*     0.000	16.09.1991	DM	alpha ver
*****************************************************************************

NULLNAME	LvlData
{					( *Level* )
ASSEMBLE
	IFNE	L01-10
RPL
    INCLUDE	lvl0data.inc		(  1 - 10 )
ASSEMBLE
	ENDIF
	IFNE	L11-20
RPL
    INCLUDE	lvl1data.inc		( 11 - 20 )
ASSEMBLE
	ENDIF
	IFNE	L21-30
RPL
    INCLUDE	lvl2data.inc		( 21 - 30 )
ASSEMBLE
	ENDIF
	IFNE	L31-40
RPL
    INCLUDE	lvl3data.inc		( 31 - 40 )
ASSEMBLE
	ENDIF
	IFNE	L41-50
RPL
    INCLUDE	lvl4data.inc		( 41 - 50 )
ASSEMBLE
	ENDIF
RPL
}

*** LvlPic ******************************************************************
* Interface :	( --> $ )
* Description :
* Ed. History :
*     0.000	16.09.1991	DM	alpha ver
*****************************************************************************

NULLNAME	LvlPic
DOCSTR
    ASSEMBLE
	REL(5)	LvlEnd
*					  Level
	IFNE	L01-10
	INCLUDE lvl0pict.inc		*  1 - 10
	ENDIF

	IFNE	L11-20
	INCLUDE lvl1pict.inc		* 11 - 20
	ENDIF

	IFNE	L21-30
	INCLUDE lvl2pict.inc		* 21 - 30
	ENDIF

	IFNE	L31-40
	INCLUDE lvl3pict.inc		* 31 - 40
	ENDIF

	IFNE	L41-50
	INCLUDE lvl4pict.inc		* 41 - 50
	ENDIF
LvlEnd
    RPL

******************************************************************************
*			End of SOKOLVL.S
******************************************************************************
